#koristimo intelovu neprefiksnu sintaksu
.intel_syntax noprefix

#pocinjemo sekciju koda
.text

#neophodno je da labela saberi koja predstavlja naziv funkcije
#bude globalno vidljiva kako bi linker mogao da razresi poziv 
#odgovarajuce funkcije saberi iz drugog modula programa (saberi.c)	
.global saberi

#definicija funkcije pocinje labelom koja odgovara nazivu funkcije
saberi:
	#PROLOG FUNKCIJE
	#Naredba enter n, 0 kreira novi stek okvir za funkciju i
        #rezervise n bajtova na steku za potrebe smestanja lokalnih
	#promenljivih. Naredba enter n, 0 zapravo odgovara sledecem
	#nizu instrukcija:
	#
	# push rbp
	# mov rbp, rsp
	# sub rsp, n
	#
	#Prva instrukcija cuva na steku pokazivac na pocetak stek 
        #okvira prethodne (pozivajuce) funkcije. Druga instrukcija 
	#postavlja pocetak stek okvira nove (pozvane) funkcije na 
	#trenutni vrh steka. Treca instrukcija pomera pokazivac 
	#vrha steka za n bajtova na gore.
	enter 0,0

	#premestamo sadrziaj registra edi (vrednost 1. argumenta funkcije)
	#u registar eax u kojem treba sracunati povratnu vrednost funkcije
	mov eax, edi

	#sabiramo sadrzaje registara eax i esi, pri cemu se rezultat 
	#primene operacije upisuje u odredisni (prvi) operand eax
	add eax, esi

	#EPILOG FUNKCIJE
	#Naredba leave skida stek okvir funkcije - dealocira rezervisanu 
	#memoriju za smestanje lokalnih promenljivih i vraca stek u stanje
	#poziva funkcije (inverzna naredba naredbe enter n, 0). Naredba 
	#leave zapravo odgovara sledecem nizu instrukcija:
	#
	# mov rsp, rbp
	# pop rbp
	#
	#Prva naredba postavlja kao trenutni vrh steka ono sto je bio
	#pocetak stek okvira izvrsene (pozvane) funkcije, sto je ujedno
	#bio kraj stek okvira pozivajuce funkcije. Druga naredba postavlja
	#za trenutni pokazivac pocetka stek okvira ranije sacuvanu vrednost 
	#na steku pokazivaca pocetka stek okvira pozivajuce funkcije.						
	leave

	#kontrolu prepustamo pozivajucoj funkciji
	ret
	
