.intel_syntax noprefix

.data
	poruka: .asciz "Nepoznata operacija!\n"
.text
.global izracunaj

# int racunaj(int a, int b, char op);
# eax	      edi    esi    dl
#NAPOMENA: kako kao treci argument prosledjujemo char, dovoljno je 
#da posmatramo najnizih 8 bitova (1 bajt) registra rdx, odnosno dl
izracunaj:
	enter 0,0
	
        #pretpostavka je da ce funkciji biti prosledjen tacno 
	#jedan od karaktera +, -, *, / ili % kao treci argument

	# poredimo sadrzaj registra dl sa karakterom +
	cmp dl, '+'
	je saberi
	
	#ukoliko uslov skoka je instrukcije nije ispunjen, nastavlja 
	#se sekvencijalno sa izvrsavanjem sledece instrukcije

	cmp dl, '-'
	je oduzmi

	cmp dl, '*'
	je pomnozi

	cmp dl, '/'
	je podeli

	cmp dl, '%'
	je po_modulu

	#ukoliko je prosledjen neki drugi karakter ispisujemo
	#poruku o gresci na stderr i zavrsavamo program  

	mov rdi, qword ptr stderr
	lea rsi, poruka
	mov rax, 0
	call fprintf
	
	#exit(EXIT_FAILURE) <=> exit(1)
	mov rdi, 1
	call exit

	jmp kraj

saberi:
	#vrsimo sabiranje i skacemo na kraj programa
	mov eax, edi
	add eax, esi
	jmp kraj

oduzmi:
	#vrsimo oduzimanje i skacemo na kraj programa
	mov eax, edi
	sub eax, esi
	jmp kraj

pomnozi:
	#vrsimo oznaceno mnozenje i skacemo na kraj programa
	#u slucaju 4-bajtnih podataka mnozi se sadrzaj registra eax (mnozenik) 
	#sa prvim i jedinim operandom instrukcije (mnozilac), a rezultat se 
	#smesta u nadovezane registre edx:eax
	mov eax, edi
	imul esi

	#kako je povratni tip oznacen 4-bajtni podatak, gornju polovinu rezultata
	#mnozenja koja smestena u registru edx zanemarujemo (jer je sa ovim 
	#potpisom funkcije ne mozemo vratiti), tj. vracamo samo donjih 4 bajta 
	#rezultata mnozenja koji su smesteni u registru eax
	jmp kraj

podeli:
	#vrsimo oznaceno deljenje i skacemo na kraj programa
	#u slucaju 4-bajtnih podataka deli se sadrzaj nadovezanih registra edx:eax 
	#(deljenik) sa prvim i jedinim operandom instrukcije (delilac), a kolicnik
	#se smesta u registar eax, dok je ostatak pri deljenju u registru edx
	mov eax, edi
	cdq              #oznaceno prosirujemo eax na edx:eax
	idiv esi

	#povratna vrednost je kolicnik koji je vec smesten u registru eax
	jmp kraj

po_modulu:
	#vrsimo oznaceno deljenje i vracamo ostatak pri deljenju iz registra edx
	mov eax, edi
	cdq 
	idiv esi

	mov eax, edx

kraj:
	leave
	ret

